2017 ACM/ICPC Asia Regional Shenyang card card card(补题)

As a fan of Doudizhu, WYJ likes collecting playing cards very much.
One day, MJF takes a stack of cards and talks to him: let’s play a game and if you win, you can get all these cards. MJF randomly assigns these cards into n heaps, arranges in a row, and sets a value on each heap, which is called “penalty value”.
Before the game starts, WYJ can move the foremost heap to the end any times.
After that, WYJ takes the heap of cards one by one, each time he needs to move all cards of the current heap to his hands and face them up, then he turns over some cards and the number of cards he turned is equal to the penaltyvalue.
If at one moment, the number of cards he holds which are face-up is less than the penaltyvalue
, then the game ends. And WYJ can get all the cards in his hands (both face-up and face-down).
Your task is to help WYJ maximize the number of cards he can get in the end.So he needs to decide how many heaps that he should move to the end before the game starts. Can you help him find the answer?
MJF also guarantees that the sum of all “penalty value” is exactly equal to the number of all cards.
Input
There are about 10 test cases ending up with EOF.
For each test case:
the first line is an integer n (1≤n≤106), denoting n heaps of cards;
next line contains n integers, the ith integer ai (0≤ai≤1000) denoting there are ai cards in ith heap;
then the third line also contains n integers, the ith integer bi (1≤bi≤1000) denoting the “penalty value” of ith heap is bi
.
Output
For each test case, print only an integer, denoting the number of piles WYJ needs to move before the game starts. If there are multiple solutions, print the smallest one.
Sample Input

5
4 6 2 8 4
1 5 7 9 2

Sample Output

4

比赛的时候,做了好多遍都是超时,自己真的是没有耐心~

#include <bits/stdc++.h>
#define INF 0x3f3f3f3f
using namespace std;
int a[2112121];//第一行卡片数
int t[2112111];//对应的卡片数-惩罚值
int main()
{
  int n;
  while(~scanf("%d", &n))
  {
     for(int i=1;i<=n;i++)
     {
       scanf("%d", &a[i]);
       a[i+n] = a[i];//因为可以移动任意次,所以最多的移动是移动n-1次,直接将数组扩大就可以,不需要移动
     }
     for(int i=1;i<=n;i++)
     {
       int k;
       scanf("%d", &k);
       t[i] = a[i] - k;//差值
       t[i+n] = t[i];//扩大数组
     }
     int sum = 0, step = 0, temp = 1;
     int l;
     int maxn = -INF;//最多的卡片数
     for(int i=1;i<=2*n;i++)
     {//注意没有必要每一个数都要当作开始点,否则,超时!!!
        sum += a[i];//卡片数
        step += t[i];//差值
        if(sum>maxn)//卡片数更新
        {
           maxn = sum;
           l = temp;//记录下标,代表移动的次数+1
        }
        if(step<0)//不符合要求
        {
          sum = 0;//清零
          step = 0;
          temp = i + 1;//更新(从当前点开始(我刚开始的时候一直不知道为什么要从当前点开始,难道不会遗漏情况吗???其实,从当前点开始,倘若之前差值之和为正,在后面也可以被加进去~)
          if(temp>n+1)//已经遍历了一遍
          break;//跳出
        }
     }
     cout<<l-1<<endl;
  }
  return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值